Subject: Re: [Bug 9750] [patch 2.6.25] dev: avoid a race that triggers assertion failure

From: Jeff Garzik <[email-masked]>
Date: Tue, 12 Feb 2008 10:58:12 -0500

Matti Linnanvuori wrote:
> From: Matti Linnanvuori <[email-masked]>
> 
> There is a race in Linux kernel file net/core/dev.c, function dev_close.
> The function calls function dev_deactivate, which calls function
> dev_watchdog_down that deletes the watchdog timer. However, after that, a
> driver can call netif_carrier_ok, which calls function
> __netdev_watchdog_up that can add the watchdog timer again. Function
> unregister_netdevice calls function dev_shutdown that traps the bug
> !timer_pending(&dev->watchdog_timer). Moving dev_deactivate after
> netif_running() has been cleared prevents function netif_carrier_on
> from calling __netdev_watchdog_up and adding the watchdog timer again.
> 
> Signed-off-by: Matti Linnanvuori <[email-masked]>
> 
> ---
> 
> --- linux-2.6.25/net/core/dev.c    2008-02-12 12:37:51.206833000 +0200
> +++ b/net/core/dev.c    2008-02-12 12:38:48.727611400 +0200
> @@ -1071,8 +1071,6 @@ int dev_close(struct net_device *dev)
>       */
>      call_netdevice_notifiers(NETDEV_GOING_DOWN, dev);
>  
> -    dev_deactivate(dev);
> -
>      clear_bit(__LINK_STATE_START, &dev->state);
>  
>      /* Synchronize to scheduled poll. We cannot touch poll list,
> @@ -1083,6 +1081,7 @@ int dev_close(struct net_device *dev)
>       */
>      smp_mb__after_clear_bit(); /* Commit netif_running(). */
>  
> +    dev_deactivate(dev);
>      /*
>       *    Call the device specific close. This cannot fail.
>       *    Only if device is UP

This is more for davem (he does net/* stuff)

	Jeff